#include <stdio.h>
#include <assert.h>

int sum(int* buf, const size_t n) {
    int ret = 0, i;
    for (i = 0; i != n; ++i) ret += buf[i];
    return ret;
}

int sum_tail_aux(int* buf, const size_t n, int acc) {
    if (n == 0) return acc;
    return sum_tail_aux(buf, n-1, acc+buf[n-1]);
}

int sum_tail(int* buf, const size_t n) { return sum_tail_aux(buf, n, 0); }

int main() {
    int buf[] = { 1, 2, 3, 4, 5, 1000 };
    const size_t n = sizeof(buf) / sizeof(buf[0]);
    assert(sum(buf, n) == sum_tail(buf, n));
}

