#include <stdio.h>
#include <assert.h>

int fib(int n) {
    if (n == 0 || n == 1)
        return n;
    return fib(n-1) + fib(n-2);
}

static int fib_tail_aux(int n, int curr, int next) {
    if (n == 0) return curr;
    return fib_tail_aux(n-1, next, curr + next);
}
int fib_tail(int n) { return fib_tail_aux(n, 0, 1); }

int fib_loop(int n) {
    if (n == 0 || n == 1)
        return n;
    int curr = 0, next = 1;
    while (n) {
        int tmp = curr;
        curr = next;
        next = tmp + curr;
        --n;
    }
    return curr;
}

int main() {
    return fib_tail(999999999);
}

